From efc24791c8ed97ace3762ef9fab1da1161918598 Mon Sep 17 00:00:00 2001
From: Charles Plessy <plessy@debian.org>
Date: Sun, 4 Aug 2013 08:50:46 +0900
Subject: [PATCH 6/6] Document the behaviour of triggers when packages are in
 intermediate states.

---
 policy.sgml | 34 +++++++++++++++++++++++++++++++++-
 1 file changed, 33 insertions(+), 1 deletion(-)

diff --git a/policy.sgml b/policy.sgml
index f57df14..8360e50 100644
--- a/policy.sgml
+++ b/policy.sgml
@@ -4157,7 +4157,9 @@ Checksums-Sha256:
 	      of circular dependencies, see the discussion
 	      in <ref id="binarydeps">.  Even when called with
 	      <tt>configure</tt>, this script must do whatever actions are
-	      necessary to deal with any triggers activation.
+	      necessary to deal with any
+	      <qref id="dpkg-triggers-intermediate-states">triggers</qref>
+	      activation.
 	    </item>
 
 	    <tag><var>old-postinst</var> <tt>abort-upgrade</tt>
@@ -4956,6 +4958,36 @@ fi
 	    the remainder of the interested package must work normally.
 	  </p>
 	</sect1>
+
+	<sect1 id="dpkg-triggers-intermediate-states">
+	<heading>The case of packages in intermediate states</heading>
+
+	  <p>
+	    Packages in "Config-Files" or "Not-Installed" do not await triggers.
+	  </p>
+
+	  <p>
+	    Packages in "Half-Configured" or worse never have pending triggers.
+	    A package is only guaranteed to become notified of a trigger
+	    activation if it is continuously interested in the trigger, and never
+	    in "Half-Configured" or worse.  A package whose postinst is being run
+	    can however acquire pending triggers during that run (ie, a package
+	    can trigger itself).
+	  </p>
+
+	  <p>
+	    However, if such a package (between "Half-Installed" and
+	    "Half-Configured" inclusive) declares some trigger interests then the
+	    triggering packages will await their configuration (which implies
+	    completion of any necessary trigger processing) or removal.
+	  </p>
+
+	  <p>
+	    For this reason, the <tt>postinst</tt> scripts must do whatever
+	    actions are necessary to deal with any trigger activation when they
+	    are called with <tt>configure</tt>.
+	  </p>
+	</sect1>
       </sect>
     </chapt>
 
-- 
1.8.4.rc0

